<?php
class ControllerExtensionPaymentKiTOcto extends Controller {
    private $error = array();

    public function index() {

        $data['payment_kit_octo_checkout_url'] = "https://secure.octo.uz/prepare_payment";
        $data['payment_kit_octo_enabled'] = 'Y';

        $this->load->language('extension/payment/kit_octo');

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST')) {

            $this->model_setting_setting->editSetting('payment_kit_octo', $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
        }

        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        if (isset($this->error['merchant_id'])) {
            $data['error_kit_octo_merchant_id'] = $this->error['merchant_id'];
        } else {
            $data['error_kit_octo_merchant_id'] = '';
        }

        if (isset($this->error['merchant_private_key'])) {
            $data['error_merchant_private_key'] = $this->error['merchant_private_key'];
        } else {
            $data['error_merchant_private_key'] = '';
        }


        if (isset($this->error['kit_octo_checkout_url'])) {
            $data['error_kit_octo_checkout_url'] = $this->error['kit_octo_checkout_url'];
        } else {
            $data['error_kit_octo_checkout_url'] = '';
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('extension/payment/kit_octo', 'user_token=' . $this->session->data['user_token'], true)
        );

        $data['action'] = $this->url->link('extension/payment/kit_octo', 'user_token=' . $this->session->data['user_token'], true);

        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

        if (isset($this->request->post['payment_kit_octo_merchant_id'])) {
            $data['payment_kit_octo_merchant_id'] = $this->request->post['payment_kit_octo_merchant_id'];
        } else {
            $data['payment_kit_octo_merchant_id'] = $this->config->get('payment_kit_octo_merchant_id');
        }

        if (isset($this->request->post['payment_kit_octo_merchant_private_key'])) {
            $data['payment_kit_octo_merchant_private_key'] = $this->request->post['payment_kit_octo_merchant_private_key'];
        } else {
            $data['payment_kit_octo_merchant_private_key'] = $this->config->get('payment_kit_octo_merchant_private_key');
        }


        if (isset($this->request->post['payment_kit_octo_enabled'])) {
            $data['payment_kit_octo_enabled'] = $this->request->post['payment_kit_octo_enabled'];
        } else {
            $data['payment_kit_octo_enabled'] = $this->config->get('payment_kit_octo_enabled');
        }

        if (isset($this->request->post['payment_kit_octo_auto_capture'])) {
            $data['payment_kit_octo_auto_capture'] = $this->request->post['payment_kit_octo_auto_capture'];
        } else {
            $data['payment_kit_octo_auto_capture'] = $this->config->get('payment_kit_octo_auto_capture');
        }

        if (isset($this->request->post['payment_kit_octo_status'])) {
            $data['payment_kit_octo_status'] = $this->request->post['payment_kit_octo_status'];
        } else {
            $data['payment_kit_octo_status'] = $this->config->get('payment_kit_octo_status');
        }

        if(empty($data['payment_kit_octo_enabled'] ))
            $data['payment_kit_octo_enabled'] = 'Y';
        if(empty($data['payment_kit_octo_auto_capture'] ))
            $data['payment_kit_octo_auto_capture'] = 'Y';

        $data['payment_kit_octo_callbak_url'] = str_replace('admin/', '', HTTPS_SERVER)."?route=extension/payment/kit_octo&f=notify_octouz";

        $data['order_return'] = str_replace('admin/', '', HTTPS_SERVER)."?route=extension/payment/kit_octo&f=OrderReturn";
        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/payment/kit_octo', $data));
    }
}