<?php
include_once DIR_APPLICATION.'model/extension/payment/kit_octo/Core/OctoCallback.php';
include_once DIR_APPLICATION.'model/extension/payment/kit_octo/Core/MySqli.php';
include_once DIR_APPLICATION.'model/extension/payment/kit_octo/Core/Error.php';
include_once DIR_APPLICATION.'model/extension/payment/kit_octo/Core/Octo.php';
class ControllerExtensionPaymentKiTOcto extends Controller {

    public function index() {

        if(isset($this->request->get['route']) and $this->request->get['route']=='checkout/confirm')
        {
            return $this->CheckoutConfirm();
        }
        elseif(isset($this->request->get['route']) and $this->request->get['route']=='extension/payment/kit_octo' And isset($this->request->get['code']) and $this->request->get['code']=='kit_octo_pay'){
            $this->PayKit_Octo();
        }
        elseif(isset($this->request->get['f']) and $this->request->get['f']=='notify_octouz')
            $this->Notify();
        else {
            return $this->CheckoutConfirm();
        }
    }

    public function CheckoutConfirm() {
        $data['button_confirm'] = $this->language->get('button_confirm');

        $this->load->model('checkout/order');

        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $out_trade_no = trim($order_info['order_id']);

        $config = array (
            'merchant_id' 			=> $this->config->get('payment_kit_octo_merchant_id'),
            'order_id'				=> $out_trade_no,
            'total'					=> (int) $order_info['total'],
            'Redirect'				=> str_replace('admin/', '', HTTPS_SERVER)."?route=extension/payment/kit_octo&f=OrderReturn",
        );


        $this->load->model('extension/payment/kit_octo');

        $response = $this->model_extension_payment_kit_octo->pagePay();
        $data['action'] = $this->model_extension_payment_kit_octo->getPostCharset($config);
        $data['form_params'] = $response;
        return $this->load->view('extension/payment/kit_octo', $data);
    }

    private function PayKit_Octo(){


        $this->load->model('checkout/order');
        $this->load->language('extension/payment/kit_octo');
        $order = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $data = [
            "test" => ($this->config->get('payment_kit_octo_enabled') === 'Y') ? true : false,
            "octo_shop_id" => $this->config->get('payment_kit_octo_merchant_id'),
            "octo_secret" => $this->config->get('payment_kit_octo_merchant_private_key'),
            "shop_transaction_id" => $order['order_id'],
            "auto_capture" => ($this->config->get('payment_kit_octo_auto_capture') === 'Y') ? true : false,
            "init_time" => date('Y-m-d H:i:s'),
            "total_sum" => $order['total'],
            "currency" => $order['currency_code'],
            "payment_methods" => [
                [
                    "method" => "uzcard"
                ],
                [
                    "method" => "humo"
                ],
                [
                    "method" => "bank_card"
                ]
            ],
            "description" => $this->language->get('order_num') . $order['order_id'],
            "return_url" =>  'http://'.$_SERVER['HTTP_HOST'].'?route=checkout/success'
        ];



        $json_data = json_encode($data);

        $curl_desc = curl_init('https://secure.octo.uz/prepare_payment');
        curl_setopt($curl_desc, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($curl_desc, CURLOPT_POSTFIELDS, $json_data);
        curl_setopt($curl_desc, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl_desc, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json',
            'Content-Length: ' . strlen($json_data),
        ));

        $result = json_decode(curl_exec($curl_desc));
        if ($result->error !== 0) {
            $form = "<h1>OCTO</h1><p style='color: red; font-weight: bold; margin-bottom: 0;'>" . $result->errorMessage . "</p>";
            echo $form;
            die();
        }
        $Get = array(
            'Amount'=>$order['total'],
            'OrderId'=>$order['order_id'],
            'CmsOrderId'=>$order['order_id'],
            'octo_uuid' => $result->octo_payment_UUID,
            'IsFlagTest'=>$this->config->get('payment_kit_octo_enabled')
        );

        $Dir_App = DIR_APPLICATION.'model/extension/payment/kit_octo/';


        define('TABLE_PREFIX', DB_PREFIX);
        define('DB_CHARSET', 'utf8mb4');
        $db_group = array(
            'DB_HOST'=>DB_HOSTNAME,
            'DB_PORT'=>DB_PORT,
            'DB_NAME'=>DB_DATABASE,
            'DB_USER'=>DB_USERNAME,
            'DB_PASS'=>DB_PASSWORD,
            'CHARSET'=>DB_CHARSET,
            'CHARSETCOLAT'=>DB_CHARSET
        );

        $return = include $Dir_App.'IndexInsertOrder.php';


        $Url = $result->octo_pay_url;

        $this->load->model('checkout/order');
        $this->model_checkout_order->addOrderHistory($order['order_id'], 1 );

        header('Location: '.$Url);
        exit();
    }

    private function Notify(){

        if($_SERVER['REQUEST_METHOD'] !== 'POST'){ return false; }
        define('TABLE_PREFIX', DB_PREFIX);
        define('DB_CHARSET', 'utf8mb4');
        $db_group = array(
            'DB_HOST'=>DB_HOSTNAME,
            'DB_PORT'=>DB_PORT,
            'DB_NAME'=>DB_DATABASE,
            'DB_USER'=>DB_USERNAME,
            'DB_PASS'=>DB_PASSWORD,
            'CHARSET'=>DB_CHARSET,
            'CHARSETCOLAT'=>DB_CHARSET
        );



        $OctoCallback = new OctoCallback($db_group);
        $request = json_decode(file_get_contents("php://input"));


        $data = [
            "octo_shop_id" => $this->config->get('payment_kit_octo_merchant_id'),
            "octo_secret" =>  $this->config->get('payment_kit_octo_merchant_private_key'),
            "shop_transaction_id" => $request->shop_transaction_id,
            "octo_payment_UUID" => $request->octo_payment_UUID,
        ];

        $json_data = json_encode($data);


        $curl_desc = curl_init('https://secure.octo.uz/prepare_payment');
        curl_setopt($curl_desc, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($curl_desc, CURLOPT_POSTFIELDS, $json_data);
        curl_setopt($curl_desc, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl_desc, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json',
            'Content-Length: ' . strlen($json_data),
        ));

        $result = json_decode(curl_exec($curl_desc));


        if($result->status == 'waiting_for_capture') {
            if($OctoCallback->checkOrder($result->shop_transaction_id, $result->octo_payment_UUID)){
                if($OctoCallback->confirmOrder($result->shop_transaction_id, $result->octo_payment_UUID)) {
                    echo json_encode(['accept_status' => 'capture']);
                    die();
                }
            }
        }

        if($result->status == 'succeeded'){
            $OctoCallback->confirmOrder($result->shop_transaction_id, $result->octo_payment_UUID);
        }

    }
}