CREATE TABLE IF NOT EXISTS `{TABLE_PREFIX}octo_transactions` (
  `transaction_id` bigint(11) NOT NULL AUTO_INCREMENT COMMENT 'идентификатор транзакции ',
  `octo_transaction_id` char(100) COLLATE utf8_unicode_ci DEFAULT NULL COMMENT 'Номер или идентификатор транзакции в биллинге мерчанта. Формат строки определяется мерчантом.',
  `octo_time` varchar(13) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Время создания транзакции Octo.',
  `octo_time_datetime` datetime NOT NULL COMMENT 'Время создания транзакции Octo.',
  `create_time` datetime NOT NULL COMMENT 'Время добавления транзакции в биллинге мерчанта.',
  `perform_time` datetime DEFAULT NULL COMMENT 'Время проведения транзакции в биллинге мерчанта',
  `amount` int(11) NOT NULL COMMENT 'Сумма платежа в тийинах.',
  `state` varchar(50) NOT NULL DEFAULT '0' COMMENT 'Состояние транзакции',
  `order_id` bigint(20) NOT NULL COMMENT 'заказ',
  `cms_order_id` char(20) COLLATE utf8_unicode_ci NOT NULL COMMENT 'номер заказа CMS',
  `is_flag_test` enum('Y','N') COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`transaction_id`),
  UNIQUE KEY `octo_transaction_id` (`octo_transaction_id`),
  UNIQUE KEY `order_id` (`order_id`,`octo_transaction_id`),
  KEY `state` (`state`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=2 ;